﻿using System;
using System.IO;
using System.Linq;
using System.Net;
using System.ServiceModel.Syndication;
using System.Windows.Media.Imaging;
using System.Xml;
using System.Collections.ObjectModel;

namespace Async.Workers
{
	class TheBadWay : IDoWork
	{
		private static readonly Uri FlickrRss = new Uri("http://api.flickr.com/services/feeds/photos_public.gne");

		public void DoWork(ObservableCollection<FlickrImage> images)
		{
            WebClient wc = new WebClient();
            string str = wc.DownloadString(FlickrRss);
            StringReader sr = new StringReader(str);
            XmlReader reader = XmlReader.Create(sr);
            SyndicationFeed feed = SyndicationFeed.Load(reader);

			foreach(SyndicationItem item in feed.Items)
			{
				Uri uri = (from link in item.Links where link.RelationshipType == "enclosure" select link.Uri).FirstOrDefault();

				byte[] data = new WebClient().DownloadData(uri);
				MemoryStream ms = new MemoryStream(data);

				BitmapImage bi = new BitmapImage();
				bi.BeginInit();
				bi.StreamSource = ms;
				bi.EndInit();

				FlickrImage fi = new FlickrImage();
				fi.Image = bi;
				fi.Title = item.Title.Text;
				images.Add(fi);
			}
		}

		public void Cancel()
		{
		}
	}
}
